﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BankAccountExample
{
    public  class CreditAccount : Account
    {
        public bool executed;    // use this function to prove that certain methods have been called

        public CreditAccount(double amt)
            : base(amt)
        {
        }

        public double getBalance()
        {
            return base.getBalance();
        }
 
        public  double   debit( double amt ) 
        {
            double bal = base.getBalance();
            if (bal - amt < 0) 
            {
                throw new InsufficientFunds();
            }
            base.debit(amt);
            executed = true;
        
            return base.getBalance();
        }
    
        public  double  credit( double amt )
        {
            base.credit(amt);
            executed = true;
        
            return base.getBalance();
        }
 
        public bool isExecuted() 
        {
            return executed;
        }
    }
}
