﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BuisnessObjectToTest
{
    public class Person : IComparable
    {
        private String _givenName;
        private String _familyName;
        private int _age;

        public Person(String fname, String gname, int age)
        {
            _givenName = gname;
            _familyName = fname;
            _age = age;
        }

        public override bool Equals( Object other )
        {
            bool result = false;

            if(! (other is Person) )
            {
		        throw new InvalidCastException("Need a Person");
            }
            Person otherPerson = (Person)other;

            if( _age == otherPerson._age
                && _familyName == otherPerson._familyName 
                && _givenName == otherPerson._givenName )
            {
                result = true;
            }
            return result;
        }

        public static bool operator ==(Person lh, Person rh)
        {
            bool result = false;

            if (System.Object.ReferenceEquals(lh, rh))
            {
                return true;
            }

            if (((Object)lh == null) || ((Object)rh == null))
            {
                return false;
            }

            if (lh._age == rh._age
                && lh._familyName == rh._familyName
                && lh._givenName == rh._givenName)
            {
                result = true;
            }
            return result;
        }

        public static bool operator !=(Person lh, Person rh)
        {
            return !(lh == rh);
        }

        public int CompareTo(object other)
        {
            if (!(other is Person))
            {
                throw new InvalidCastException("Need a Person");
            }
            Person otherPerson = (Person)other;

            return _age - otherPerson._age;
        }
    }
}
