﻿
namespace TDD.Mocking
{
    // Used by OrderReader2 
    /*
    "This method is easy. Add a setter to the factory and set it to a fake
     dependency of your choice. There’s no changing of the semantics of
     the code base, everything stays the same, and the code is dead simple.
     The only con is that this method requires that you understand
     who calls the factory and when, which means you need to do some
     research before you can implement this easily." Osherove, p. 70
     */
    public class FileReaderFactory
    {
        private static IFileReader _fileReader = new FileReader();

        public static IFileReader Create()
        {
            return _fileReader;
        }

        public static void SetReader(IFileReader fileReader_)
        {
            _fileReader = fileReader_;
        }

    }
}
