﻿Imports NUnit.Framework
Imports Rhino.Mocks

Namespace TDD.Mocking
    <TestFixture()> _
    Class OrderReader2RhinoTest
        Private repository As MockRepository
        Private mockFileReader As IFileReader
        Private orderReader As OrderReader2

        <SetUp()> _
        Public Sub SetUp()
            repository = New MockRepository()
            ' Set the mock to be the factory's FileReader
            mockFileReader = repository.StrictMock(Of IFileReader)()
            FileReaderFactory.SetReader(mockFileReader)
            orderReader = New OrderReader2()
        End Sub

        <Test()> _
        Public Sub TestReadOrder0()
            Rhino.Mocks.Expect.Call(mockFileReader.FileName).SetPropertyWithArgument("record.csv")
            Rhino.Mocks.Expect.Call(mockFileReader.ReadLine()).Return("27412,FUBAR,876543.21")
            mockFileReader.Close()
            LastCall.Repeat.Once()
            repository.ReplayAll()

            Dim order As Order = orderReader.ReadOrder()
            repository.VerifyAll()

            Assert.That(order.OrderId, [Is].EqualTo(27412))
            Assert.That(order.Customer, [Is].EqualTo("FUBAR"))
            Assert.That(order.Price, [Is].EqualTo(876543.21))
        End Sub
    End Class
End Namespace
